package com.gxx.sharding.service;

import java.util.List;

import com.gxx.sharding.base.vo.User;

/**
 * <dl>
 *    <dt><b>Title:</b></dt>
 *    <dd>
 *    	用户服务接口
 *    </dd>
 *    <dt><b>Description:</b></dt>
 *    <dd>
 *    	<p>none
 *    </dd>
 * </dl>
 *
 * @author Administrator
 * @version 1.0, 2015年6月18日
 * @since sharding
 *
 */
public interface UserService {
	/**
	 * 新增用户
	 * @param user
	 */
	public void doSaveUser(User user);
	
	/**
	 * 修改用户
	 * @param user
	 */
	public int doUpdateUser(User user);
	
	/**
	 * 删除用户
	 * @param user
	 */
	public int doDeleteUser(User user);
	
	/**
	 * 根据id查询用户
	 * @param userId
	 * @return
	 */
	public User getUserByUserId(long userId);
	
	/**
	 * 根据id集合查询用户
	 * @param userIdList
	 * @return
	 */
	public List<User> queryUsersInUserId(List<Long> userIdList);
	
	/**
	 * 根据id区间查询用户
	 * @param beginUserId
	 * @param endUserId
	 * @return
	 */
	public List<User> queryUsersBetweenUserId(Long beginUserId, Long endUserId);

	/**
	 * 计数
	 * @return
	 */
	public long countUser();

	/**
	 * 求和
	 * @return
	 */
	public long sumUser();

	/**
	 * 取小
	 * @return
	 */
	public long minUser();

	/**
	 * 取大
	 * @return
	 */
	public long maxUser();

	/**
	 * 平均
	 * @return
	 */
	public double avgUser();
	
	/**
	 * 根据limit区间查询用户
	 * @param beginUserId
	 * @param num
	 * @return
	 */
	public List<User> queryUsersLimitUserId(Long beginUserId, Long num);
	
//	/**
//	 * 根据姓名查用户
//	 * @param name
//	 * @return
//	 */
//	public User getUserByName(String name);
}
